-- Persano 1943 --
-- par hitandrun --
-- Merci  Steelwedge --


--------------------------------------------------------------------


----- SCRIPT ID -----

--German--
-- 	101	NW Arm --
-- 	102	1st Art - 105 support vehicles (R102) --
-- 	103	2nd Art - sFh18 150s  (R105) --
-- 	104	Central Stug group --
--	105	Hv Armour Trucks --
--	106	II AufK --
--	107	105 guns (R102) --
--	108	Nashorns
--`	110	Engineer Replacement --
--	111	Hv Armour Recon --
--	112 	Hv Armour Tanks --
--	113	Central Stug Armour --
--	114	Central Stug Replacements --
--	131	II AufK Sniper -- Oberfeldwebel
--	135	Tre Reinf Inf --
--	150	Staff Car --
--	151 	Officer --
--	152	Outriders --
--	160	R104 1st Truck (R104) --
--	161	R104 2nd Trucks (R104) --
--	162	R104 Outrider (R104) --
--	170	Medal Terrain --

--USA--
--	201	Town Arm --
--	202	Long Toms (R216) --
--	203	Factory Troops --
--	204  	E Arm --
--	205	W Arm --
--	206	SE road Arm --
-- 	207 	SE road AA & M3 --
--	208 	GB Art relief Cromwell & Inf (R208) --
-- 	209 	Town Inf --
--	210	GB Art relief Churchill (R208) --
--	211	CounterBatt --
--	213	Mines Arm --
--	215	1st Priest --
-- 	216	Post-Farm Counterattack --
--	217 	Troop Truck after Roadblock1 --
--	230	Factory Inf --
--	231	Tre Sniper --
--	232	Factory Others --
--	233	W Guns Inf --
--	234	W Guns --
--	235	E Guns Inf --
--	236	Bivio Sniper --
-- 	237	2nd GB Sniper --
-- 	238 	Bivio Bridge CA --
--	239 	LT CA --
--	240	Patrol 6  (R150) --
--	241	British Bivio W -- 
--	242	British Bivio E (R241) --
--	243	Factory 155 (R102) --
--	251	Farm CA  W --
--	252	Farm CA E (R251) -- 
	


----- INITIAL ROUTINES -----

function DebugView() --OK--
	Password("Panzerklein");
	DisplayTrace("Mt. Eboli: devant la ville de Persano, Italie du Sud.");
	DisplayTrace("13 septembre 1943");
	DisplayTrace(" par hitandrun");
	RunScript("Credits", 20000);
	--ShowActiveScripts(); --TESTING--
	--God(0, 2); --TESTING--
	Suicide();	
end;

function Credits()
	DisplayTrace("Script support par Steelwedge");
	DisplayTrace("Test par mimisko, [BKP] et  Joseph_Porta");
	DisplayTrace("Erreurs, fautes et crash par hitandrun");
	Suicide();
end;


function Init() --OK--
	RunScript("DebugView", 5000);
	RunScript("InitialVariables", 500);
	RunScript("InitialAviation", 1000);
	RunScript("MissionControl", 6000);
end;

function InitialAviation() --OK--
	SwitchWeather(0);
	SwitchWeatherAutomatic(0);
	DisableAviation(0, 0); 
	DisableAviation(0, 1); 
	DisableAviation(0, 2);
	DisableAviation(0, 3);
	DisableAviation(0, 4);
	DisableAviation(1, 0); 
	EnableAviation(1, 1); 
	DisableAviation(1, 2); 
	DisableAviation(1, 3); 
	DisableAviation(1, 4); 
	Suicide();
end;

function InitialVariables() --OK--
	SetIGlobalVar("Batt.1", 0);
	SetIGlobalVar("Batt.2", 0);
	SetIGlobalVar("Batt.Prep", 0);	
	SetIGlobalVar("Block.1", 0);
	SetIGlobalVar("BomberPrep.1", 0); 
	SetIGlobalVar("BridgeStatus.1", 0);
	SetIGlobalVar("BridgeStatus.2", 0);
	SetIGlobalVar("CounterBatt.1", 0);
	SetIGlobalVar("CounterBatt.2", 0);
	SetIGlobalVar("Flank.0", 0);
	SetIGlobalVar("GBscouts.1", 0);
	SetIGlobalVar("GermanArtState.0", 0);
	SetIGlobalVar("Loaded.1", 0); -- NEW --
	SetIGlobalVar("Mines.1", 0);
	SetIGlobalVar("Objective.2.Start", 0);
	SetIGlobalVar("Objective.2.Count", 0);
	SetIGlobalVar("Objective.2.Complete", 0);
	SetIGlobalVar("Objective.3.Start", 0);
	SetIGlobalVar("Objective.3.Count", 0);    
	SetIGlobalVar("Objective.3.Complete", 0);
	SetIGlobalVar("Objective.4.Start", 0);
	SetIGlobalVar("Objective.4.Count", 0); 
	SetIGlobalVar("Objective.4.Complete", 0);
	SetIGlobalVar("Objective.4.Airstrike", 0); 
	SetIGlobalVar("Objective.5.Start", 0);
	SetIGlobalVar("Objective.5.Count", 0);
	SetIGlobalVar("Objective.5.Complete", 0);
	SetIGlobalVar("Objective.6.Start", 0);
	SetIGlobalVar("Objective.6.Count", 0);
	SetIGlobalVar("Objective.6.Complete", 0);
	SetIGlobalVar("Patrol.5", 0);
	SetIGlobalVar("PriestCount.0", 0); 
	SetIGlobalVar("R216.Count", 0); 
	SetIGlobalVar("Stug.0", 0); 
	SetIGlobalVar("TobaccoTroops.1", 0);
	SetIGlobalVar("TobaccoTroops.2", 0);
	SetIGlobalVar("TobaccoTroops.3", 0);
	SetIGlobalVar("TownStatus.1", 0);
	SetIGlobalVar("TownStatus.2", 0);
	SetIGlobalVar("TownStatus.3", 0);
	SetIGlobalVar("TreStart.1", 0);
	SetIGlobalVar("TreComplete.1", 0);
	Suicide();
end;


----- MISSION CONTROL ROUTINES -----

function MissionControl() 
	RunScript("AviationControl", 3000);
	RunScript("Batt1", 3000);
	RunScript("Batt2", 3000);
	RunScript("Batt3", 3000); 
	RunScript("Bridge", 3000); 
	RunScript("GBscouts", 3000);
	RunScript("GermanBridge", 3000);
	RunScript("GermanArtState", 3000);
	RunScript("LongToms", 3000); 
	RunScript("Mines", 3000);
	RunScript("Mines3", 3000);	
	RunScript("ObjectiveCheck", 3000);
	RunScript("Objective4Count", 3000); -- New --
	RunScript("PatrolControl", 3000);
	RunScript("PlanesIn",3000); 
	RunScript("ReinforcementControl", 3000);
	RunScript("RevealObjective1", 2000);
	RunScript("South", 3000);
	RunScript("ToLoose1", 3000);
	--RunScript("ToLoose2", 3000);
	RunScript("ToWin", 10000);
	RunScript("Town", 3000);
	SetIGlobalVar("TreStart", 1);
	Suicide();
end;
	
function ObjectiveCheck() --OK--
	if (GetIGlobalVar("Objective.3.Complete", 0) * (GetIGlobalVar("Objective.4.Complete", 0) == 1)) then 
	RunScript("RevealObjective5", 3000);
	Suicide();
end;
end;

-----  WINLOOSE ROUTINES -----

function ToLoose1() --OK--
	if (GetIGlobalVar("Objective.3.Start", 0) == 0) and
	(GetNUnitsInParty(0) <= 3) then
	DisplayTrace("Vous avez le surnom de "Boucher" suite  la manire de conduire vos hommes.  Sortez des rangs !");
	Loose();
	Suicide();
end;
end;

function ToLoose2() 
	if GetIGlobalVar("Objective.3.Start",0) == 1 and
	GetNUnitsInParty(0) <= 10 then
	DisplayTrace("Vous avez le surnom de "Boucher" suite  la manire de conduire vos hommes.  Sortez des rangs !");
	Loose();
 	KillScript("ToLoose1", 1000);
	Suicide();
end;
end;

function ToLoose3() -- NEW --
	if GetNUnitsInArea(0, "Tre") == 0 and 
	GetNUnitsInArea(1, "Tre") > 0 and
	GetIGlobalVar("Objective.2.Start", 0) > 0 then
	DisplayTrace("La base dePalladino est tombe, vous ne pouvez supporter la contre-offensive.");
	Loose();
	Suicide();
end;
end;

function ToWin() 
	if (GetIGlobalVar("Objective.3.Complete", 0) * GetIGlobalVar("Objective.4.Complete", 0) * GetIGlobalVar("Objective.5.Complete", 0) * GetIGlobalVar("Objective.6.Complete", 0)) == 1 then
	Win(0);
	Suicide();
end;
end;

----- OBJECTIVE ROUTINES -----

function RevealObjective1() --OK--
	if GetIGlobalVar("TreStart", 0) == 1 then
	ObjectiveChanged(0, 0);
	EnableAviation(0, 0);
	EnableAviation(0, 1);
	RunScript("TreCount", 3000);
	RunScript("PriestCount", 4000); 
	Suicide();
end;
end;

function TreCount() --OK--
	if(GetNUnitsInArea(1, "Tre") <= 2) then
	SetIGlobalVar("TreComplete.1", 1);
	Cmd(3, 131, 6123, 11895);
	ObjectiveChanged(0, 1);
	RunScript("RevealObjective2", 10000);
	Suicide();
end;
end;

function PriestCount()  
	if GetNUnitsInArea(1, "Tre") <= 4 then
	SetIGlobalVar("PriestCount.0", 1);
	Suicide();
end;
end;

function RevealObjective2() --OK--
	ObjectiveChanged(1, 0);
	SetIGlobalVar("Objective.2.Start", 1);
	RunScript("ToLoose3", 1000); -- NEW --
	RunScript("Block", 5000);
	Suicide();
end;

function Block() --OK--
	if (GetNUnitsInArea(0, "Roadblock") > 0) then
	DisplayTrace("Dgagez le barrage pour que les blinds puissent passer.");
	RunScript("Patrol4", 60000); 
	RunScript("Objective2", 3000);
	Suicide();
end;
end;

function Objective2() --OK--
	if (GetNUnitsInArea(1, "Roadblock1") <= 2) then
	ObjectiveChanged(1, 1);
	SetIGlobalVar("Objective.2.Complete", 1);
	RunScript("RevealObjective3", 10000);
	Suicide();
end;
end;

function RevealObjective3() --OK--
	ObjectiveChanged(2, 0);
	SetIGlobalVar("Objective.3.Start", 1);
	RunScript("Bivio", 3000);
	RunScript("BomberCount", 2000); -- NEW --
	RunScript("BomberCall", 3000); -- NEW --
	RunScript("Objective3", 10000);
	Cmd(0, 215, 9667, 9302);  
	-- RunScript("GermanArtState", 5000);
	Suicide();
end;

function Bivio() --OK--
	if GetNUnitsInArea(0, "Bivio2") >= 1 and
	GetIGlobalVar("Objective.3.Start", 0) == 1 then -- NEW --
	SetIGlobalVar("Objective.3.Count", 1);
	DisableAviation(1, 0); -- NEW --
	Suicide();
end;
end;

function BomberCount() -- NEW --
	if GetNUnitsInArea(1, "Bivio") <= 3 and 
	GetNUnitsInArea(0, "Bivio2") > 0 and
	GetIGlobalVar("Loaded.1", 0) ~= 1 then -- NEW --	
	RunScript("BomberPrep", 3000);
	Suicide();
end;
end;

function BomberPrep() -- NEW --
if GetIGlobalVar("Objective.3.Complete", 0) ~= 1 then
	DisableAviation(1, 0);
	DisableAviation(1, 1);
	SetIGlobalVar("BomberPrep.1", 1);
	else
	KillScript("BomberCount", 2000);
	SetIGlobalVar("BomberPrep.1", 0);
	Suicide();
end;
end;

function Objective3() --OK--
	if GetNUnitsInArea(1, "Bivio") <= 2 then
	SetIGlobalVar("Objective.3.Complete", 1);
	ObjectiveChanged(2, 1);
	RunScript("Medal", 180000); 
	RunScript("RevealObjective4", 20000);
	Suicide();
end;
end;

function RevealObjective4() --OK-- 
	if GetIGlobalVar("Objective.3.Complete", 0) == 1 then
	ObjectiveChanged(3, 0);
	SetIGlobalVar("Objective.4.Start", 1);
	RunScript("Objective4", 5000);
	Cmd(3, 236,1036, 13218); -- Suicide mission for Bivio sniper --
	Suicide();
end;
end;


function Objective4() --OK--
	if (GetNUnitsInArea(1, "Farm") <= 4) then
	ObjectiveChanged(3, 1);
	SetIGlobalVar("Objective.4.Complete", 1);
	SetIGlobalVar("Objective.4.Airstrike", 1);  
	KillScript("Stug_Reinf", 1000); 
	Suicide();
end;
end; 
	
function RevealObjective5() --OK-- 
	ObjectiveChanged(4, 0);
	SetIGlobalVar("Objective.5.Start", 1);
	RunScript("Objective5", 3000);
	RunScript("FactoryCA", 3000); -- NEW -- 
	RunScript("Rout", 1000);
	Suicide();
end;

function FactoryCA() 
ArmW = GetNUnitsInScriptGroup(205);
ArmE = GetNUnitsInScriptGroup(204);
	if GetNUnitsInArea(0, "Tobacco") >=2 and
	GetIGlobalVar("TobaccoTroops.3", 0) == 1 then -- NEW --
		if ArmW > ArmE then
		Cmd(3, 205, 9990, 6680);
		elseif ArmW <= ArmE then
		Cmd(3, 205, 9990, 6680);
	end;
	Suicide();
end;
end;
		

function TobaccoTroops() --OK--
	SetIGlobalVar("TobaccoTroops.1", GetNUnitsInArea(1, "Tobacco"));
	SetIGlobalVar("TobaccoTroops.2", (GetIGlobalVar("TobaccoTroops.1", 0) / 3));
	RunScript("TobaccoTroops2", 1000); 
	Suicide();
end;

function TobaccoTroops2() --OK--
	if GetNUnitsInArea(1, "Tobacco") <= GetIGlobalVar("TobaccoTroops.2", 0) then
	SetIGlobalVar("TobaccoTroops.3", 1);
	Suicide();
end;
end;

function Rout() --OK--
	if GetIGlobalVar("TobaccoTroops.3", 0) == 1 then
	RunScript("Delete_203", 2000); 
	RunScript("Delete_230", 2000);
	RunScript("Delete_232", 2000); 
	ChangeFormation(230, 3); -- NEW --
	ChangePlayer(230, 2); -- NEW --
	Cmd(0, 203, 8995, 45);
	Cmd(0, 230, 8995, 45); 
	Cmd(0, 232, 8995, 45); 
	--Americans run away when 1/3 of defenders are killed---
	DisplayTrace("Les lignes amricaines sont perce, repoussez-les  la mer !"); 
	Suicide();
end;
end;

function Delete_203() 
	if (GetNUnitsInScriptGroup(203) == 0) then
	Suicide();
	else
	if (GetNScriptUnitsInArea(203, "Vanish") > 0) then
	DeleteReinforcement(203);
	Suicide();
end;
end;
end;	
	
function Delete_230() 
	if (GetNUnitsInScriptGroup(230) == 0) then
	Suicide();
	else
	if (GetNScriptUnitsInArea(230, "Vanish") > 0) then
	DeleteReinforcement(230);
	Suicide();
end;
end;
end;

function Delete_232() 
	if (GetNUnitsInScriptGroup(232) == 0) then
	Suicide();
	else
	if (GetNScriptUnitsInArea(232, "Vanish") > 0) then
	DeleteReinforcement(232);
	Suicide();
end;
end;
end;

function Objective5() --OK--
	SetIGlobalVar("Objective.5.Count", 1);
	if GetNUnitsInArea(1, "Tobacco") <= 5 then
	SetIGlobalVar("Objective.5.Complete", 1);
	ObjectiveChanged(4, 1);
	Suicide();
end;
end;

function RevealObjective6() -- NEW -- 
	ObjectiveChanged(5, 0);
	SetIGlobalVar("Objective.6.Start", 1);
	RunScript("Objective6", 3000);
	Suicide();
end;

function Objective6() -- NEW --
	SetIGlobalVar("Objective.6.Count", 1);
	if GetPartyOfUnits(202) == 0 then
	SetIGlobalVar("Objective.6.Complete", 1);
	ObjectiveChanged(5, 1);
	DisplayTrace("Si vous tenez l'artillerie lourde amricaine, vous dominerez le champs de bataille.");
	elseif
	GetNUnitsInScriptGroup(202) == 0 then
	SetIGlobalVar("Objective.6.Complete", 1);
	ObjectiveChanged(5, 2);
	DisplayTrace("Vous tiez suppos prendre ces canons, non les dtruire !");
	DisplayTrace("Tentez de suivre les ordres : capturez la manufacture.");
	Suicide();
end;
end;


----- AREA RESPONSE -----

function Batt1() --OK--
	if GetIGlobalVar("Objective.3.Start", 0) == 1 and
	(GetNUnitsInArea(0, "Batt1") > 0) then
	SetIGlobalVar("Batt.1", 1);
	Suicide();
end;
end;

function Batt2() --OK--
	if GetIGlobalVar("Objective.4.Start", 0) == 1 and
	(GetNUnitsInArea(0, "Batt2") > 0) then
	SetIGlobalVar("Batt.2.", 1);
	Suicide();
end;
end;

function Batt3() 
	if GetNUnitsInArea(0, "Batt3") > 0 then
	DisplayTrace("Les Amricains tentent d'enclouer leurs canons pour viter leur prise.");
	Cmd(7, 233, 12595, 1619);
	QCmd(1, 233, 234);
	QCmd(1, 233, 234); -- NEW --
	RunScript("Batt4", 2000); 
	Suicide();
end;
end;	

function Batt4() -- NEW --
	if GetNUnitsInScriptGroup(234) == 0 then 
	Suicide();
	else
		if GetPartyOfUnits(234) == 0 then
		DamageObject(234, GetObjectHPs(234));
		DisplayTrace("Trop tard ! Les canons sont inutilisables.");
	end;
	Suicide();
end;
end;

-- Bombardment -- Made in Finland --

function Bombardment() 
Bx,By, Ba, Bb = GetScriptAreaParams("LongTom"); -- NEW --
BLen = 2 * Ba / 10;
BWid = 2 * Bb / 10;
	RunScript("Barrage1", 3000);
	Suicide();
end;

function Barrage1() 
BRandX = (RandomInt((10) * BLen) - Ba);
BRandY = (RandomInt((10) * BWid) - Bb);
	Cmd(15, 202, (BRandX + Bx), (BRandY + By));
	RunScript("RevealObjective6", 10000); -- NEW --
	RunScript("Barrage2", 20000);
	Suicide();
end;

function Barrage2() 
BRandX = BRandX + 200;
BRandY = BRandY + 200;
	Cmd(15, 202, (BRandX + Bx), (BRandY + By));
	RunScript("BarrageEnd", 20000);
	Suicide();
end;

function BarrageEnd() 
	Cmd(9, 202);
	Suicide();
end;


-- Bridge --

function Bridge() --OK--
	if GetIGlobalVar("Objective.4.Start", 0) == 1 then
	RunScript("BridgeCount", 3000);
	RunScript("BridgeCount2", 180000);
	Suicide();
end;
end;

function BridgeCount() --OK--
	if GetNUnitsInArea(0, "Bridge") > 0 then
	SetIGlobalVar("BridgeStatus.1", 1);
	DisplayTrace("Les Amricains ont fait sauter ce pont."); 
	Suicide();
end;
end;

function BridgeCount2() --OK--
	if GetIGlobalVar("BridgeStatus.1", 0) ==1 and
	GetNUnitsInArea(0, "Bridge") <= 1 then
	SetIGlobalVar("BridgeStatus.2", 1);
	Suicide();
end;
end;
-----	

function Forest() -- NEW --
	if GetNUnitsInScriptGroup(204) >= 2 and
	GetNUnitsInArea(0, "Forest") >= 2 then
	Cmd(3, 204, 6095, 6920);
	QCmd(3, 204, 7145, 4450);
	QCmd(8, 5450, 9785);
	Suicide();
end;
end;

function GBscouts() --OK--
	if GetNUnitsInArea(0, "GBZone1") > 1 then
	SetIGlobalVar("Patrol.5", 1);
	Suicide();
end;
end;

--function GermanArtState() --NOT WORKING--
--	if (GetUnitState(107) == 16) or
--	(GetUnitState(107) == 34) then
--	SetIGlobalVar("GermanArtState.0", 1);
--	Suicide();
--end;
--end;
-- This function is supposed to LandReinforcement(211) which will attack Tre Palladino and then search out German 105 guns (ID 107) --
 
function GermanBridge() --OK--
	if GetObjectHPs(25) >= 0 then
	DisplayTrace("Brillante manoeuvre commandant ! Vous pouvez attaquer les Allis par les flancs.");
	SetIGlobalVar("Flank.0", 1);
	SetIGlobalVar("Mines.1", 1); 
	Suicide();
end;
end;

function LongToms() 
	if GetNUnitsInArea(0, "SE") > 0 then
	DisplayTrace("Les Amricains tentent d'enclouer leurs canons pour viter leur prise.");
	Cmd(7, 235, 16875, 2615);
	QCmd(1, 235, 202);
	QCmd(1, 235, 202); 
	RunScript("LT_Spike", 3000); -- NEW --
	Suicide();
end;
end;	

function LT_Spike() -- NEW --
	if GetNUnitsInScriptGroup(202) == 0 then 
	Suicide();
	else
		if GetPartyOfUnits(202) == 0 then
		DamageObject(202, GetObjectHPs(202));
		DisplayTrace("Trop tard ! Les canons sont inutilisables.");
	end;
	Suicide();
end;
end;

-- Mines --

function Mines() --OK--
	if GetIGlobalVar("Objective.4.Start", 0) == 1 then
	RunScript("Mines1", 1000);
	RunScript("Mines2", 1000);
	Suicide();
end;
end;

function Mines1() --OK--
	if (GetNUnitsInArea(0, "XRoads") > 0) then
	SetIGlobalVar("Mines.1", 1);
	Suicide();
end;
end;

function Mines2() --OK-- 
	if GetIGlobalVar("Mines.1", 0) == 1 and
	(GetNUnitsInArea(0, "MInes")  > 0) then
	DisplayTrace("Les sapeurs amricains posent des mines sur l'axe d'approche Est de la manufacture de tabac, il doit y avoir une route plus facile.");
	Suicide();
end;
end;


function Mines3()  
	if GetNUnitsInArea(0, "Mines2")  > 0 then
	DisplayTrace("Les sapeurs anglais posent des mines sur l'axe d'approche Ouest de la manufacture de tabac, il doit y avoir une route plus facile.");
	Suicide();
end;
end;
-----

function Objective4Count() -- NEW --
	if GetNUnitsInArea(0, "Farm") >= 3 then 
	SetIGlobalVar("Objective.4.Count", 1);
	Suicide();
end;
end;

function R216_Count() -- NEW --
	if GetNUnitsInScriptGroup(216) <= 2 then
	SetIGlobalVar("R216.Count", 1);
	Suicide();
end;
end;

function South() --OK--
	if GetIGlobalVar("Objective.3.Complete", 0) == 1 and
	GetNUnitsInArea(0, "South") > 0 then
	DisplayTrace("Les Amricains ont aussi dbarqu une batterie lourde d'artillerie au Sud du Canale Di Bonificamento.");
	Suicide();
end;
end;

function Stug_Reinf() -- OK --
	if GetIGlobalVar("Objective.4.Complete", 0) == 0 and
	GetNUnitsInScriptGroup(113) <= 2 then
	SetIGlobalVar("Stug.0", 1);
	RunScript("Stug_Complete", 3000);
	Suicide();
end;
end;

function Stug_Complete()  -- OK --
	KillScript("Stug_Reinf", 1000);
	Suicide();
end;

--Town --

function Town() --OK--
	if GetIGlobalVar("Objective.4.Start", 0) == 1 then
	RunScript("TownCount1", 1000);
	RunScript("TownCount2", 1000);
	RunScript("TownCount3", 1000);
	RunScript("TownOrders1", 1000);
	RunScript("TownOrders2", 1000);
	RunScript("TownOrders3", 1000);
	Suicide();
end;
end;

function TownCount1() --OK--
	if (GetNUnitsInArea(0, "Town1") > 0) then
	SetIGlobalVar("TownStatus.1", 1);
	Suicide();
end;
end;

function TownCount2() --OK--
	if (GetNUnitsInArea(0, "Town2") > 0) then
	SetIGlobalVar("TownStatus.2", 1);
	RunScript("PlanesOut", 1000); -- NEW --
	Suicide();
end;
end;

function TownCount3() --OK--
	if (GetNUnitsInArea(1, "Town2") <= 2) then
	SetIGlobalVar("TownStatus.3", 1);
	Suicide();
end;
end;

function TownOrders1() --OK--
	if GetIGlobalVar("TownStatus.1", 0) == 1 then
	DisplayTrace("Le QG amricain est dans Persano.  Votre objectif du jour est la manufacture.");
	Suicide();
end;
end;

function TownOrders2() --OK--
	if GetIGlobalVar("TownStatus.2", 0) == 1 then
	DisplayTrace("FieldMarshal Kesselring n'oubliera pas que l'attaque principale a chou  cause de votre dsobssance !");
	Suicide();
end;
end;

function TownOrders3() --OK--
	if GetIGlobalVar("TownStatus.3", 0) == 1 then
	DisplayTrace("Flicitations commandant.  Grce  votre manoeuvre l(attaque de demain sera facilite.");
	Suicide();
end;
end;

----- REINFORCEMENTS -----

function ReinforcementControl() --OK--
local t = RandomInt(40) + 1
	RunScript("Armour_Delay", 3000); 
	RunScript("Reinf101", 3000);
	RunScript("Reinf102", 3000); 
	RunScript("Reinf103", 3000);
	RunScript("Reinf104", 3000);
--	RunScript("Reinf105", 3000); -- controlled by Armour_Delay --
	RunScript("Reinf106", 3000);
	RunScript("Reinf108", 10000); 
	RunScript("Reinf114", 3000); 
	RunScript("Reinf170", 3000); 
	RunScript("Reinf201", 3000);
	RunScript("Reinf202", 3000); 
--	RunScript("Reinf203", 3000);
	RunScript("Reinf204", 3000);
	RunScript("Reinf205", 3000);
	RunScript("Reinf206", 90000);
	RunScript("Reinf207", 3000);
	RunScript("Reinf208", 3000);
	RunScript("Reinf209", 3000);
	RunScript("Reinf211", 3000);
	RunScript("Reinf213", 3000);
	RunScript("Reinf215", 3000);
	RunScript("Reinf238", 3000); 
	RunScript("Reinf239", 3000); 
	RunScript("Reinf240", 3000); 
	RunScript("Reinf241", 3000); 
	RunScript("Reinf243", 3000);  
	RunScript("Reinf251", (t * 1000)); -- NEW-- 
	Suicide();
end;

function Armour_Delay() 

if GetIGlobalVar("Objective.5.Count", 0) == 1 then
	RunScript("Reinf103)", 300000); -- NEW --
	RunScript("Reinf105", 180000);
	RunScript("Reinf111", 3000);
	RunScript("Reinf112", 90000);
	RunScript("Reinf203", 75000);
	RunScript("Reinf216", 15000);
	RunScript("ReinfCheck", 30000);
	RunScript("TobaccoTroops", 80000);
	Suicide();
end;
end;

function ReinfCheck() -- OK --
	if GetIGlobalVar("Stug.0", 0) == 0 and
	GetIGlobalVar("Objective.5.Count", 0) == 1 then
	LandReinforcement(114);
	Suicide();
end;
end;

function Reinf101()
-- NW Arm --
	if GetIGlobalVar("Objective.3.Start", 0) == 1 then
	LandReinforcement(101);
	Suicide();
end;
end;

function Reinf102()
-- 105 support vehicles --
	if GetIGlobalVar("Objective.3.Count", 0) == 1 then
	LandReinforcement(102);
	Suicide();
end;
end;

function Reinf108()
-- Nashorns --
	if GetIGlobalVar("Flank.0", 0) == 1 then
	LandReinforcement(108);
	Suicide();
end;
end;

function Reinf104()
-- Central Stug group --
	if GetIGlobalVar("Objective.4.Start", 0) == 1 then
	LandReinforcement(104);
	Cmd(39, 160, 162); -- NEW --
	Cmd(39, 161, 160); -- NEW --
	RunScript("Stug_Reinf", 60000); 
	Suicide();
end;
end;

function Reinf105()
-- Hv Arm --
	if GetIGlobalVar("Objective.5.Count", 0) == 1 then
	LandReinforcement(105);
	Suicide();
end;
end;

function Reinf106()
-- 2nd AufK --
	if GetIGlobalVar("Objective.2.Start", 0) == 1 then
	LandReinforcement(106);
	Suicide();
end;
end;

function Reinf108() -- NEW --
-- Nashorns --
	if GetIGlobalVar("Flank.0", 0) == 1 then
	LandReinforcement(108);
	Suicide();
end;
end;

function Reinf111() 
-- Hv Recon --
	if GetIGlobalVar("Objective.5.Start", 0) == 1 then
	LandReinforcement(111);
	Suicide();
end;
end;

function Reinf112() 
-- Hv Armour --
	if GetIGlobalVar("Objective.5.Start", 0) == 1 then
	LandReinforcement(112);
	DisableAviation(1, 0); -- NEW --
	KillScript("PlanesIn", 2000); -- NEW --
	KillScript("PlanesOut", 2000); -- NEW --
	Suicide();
end;
end;

function Reinf114()
-- Stug Reinf --
	if GetIGlobalVar("Stug.0", 0) == 1 then
	DisplayTrace("Votre compagnie de semi-chenille a t touche. Il ne reste que des chars obsoltes en rserve.");
	LandReinforcement(114);
	Suicide();
end;
end;

function Reinf150() 
-- Medal Party --
	if GetIGlobalVar("Objective.3.Complete", 0) == 1 then
	LandReinforcement(150);
	ViewZone("Medal", 1);
	Suicide();
end;
end;

function Reinf170() -- NEW --
	if GetIGlobalVar("Loaded.1", 0) == 1 then
	LandReinforcement(170);
	Suicide();
end;
end;	

function Reinf201()
-- Town Arm --
	if GetIGlobalVar("TownStatus.1", 0) == 1 then
	LandReinforcement(201);
	Suicide();
end;
end;

function Reinf202()
	if GetIGlobalVar("R216.Count", 0) == 1 then
	LandReinforcement(202);
	RunScript("Bombardment", 6000);
	Suicide();
end;
end;

function Reinf203()
-- Factory troops --
	if GetIGlobalVar("Objective.5.Start", 0) == 1 then
	LandReinforcement(203);
	Suicide();
end;
end;

function Reinf204()
--E  Arm --
	if GetIGlobalVar("Objective.4.Start", 0) == 1 then
	LandReinforcement(204);
	Suicide();
end;
end;
	
function Reinf205() -- NEW --
-- W Arm --
	if GetIGlobalVar("Objective.4.Complete", 0) == 1 then
	LandReinforcement(205);
	Suicide();
end;
end;

function Reinf206()
-- SE Road Arm --
	if GetIGlobalVar("BridgeStatus.1", 0) == 1 then
	LandReinforcement(206);
	Suicide();
end;
end;

function Reinf207()
-- SE Road AA & M3 --
	if GetIGlobalVar("BridgeStatus.2", 0) == 1 then
	LandReinforcement(207);
	Suicide();
end;
end;

function Reinf208()
-- GB Art relief --
	if GetIGlobalVar("Batt.1", 0) == 1 then
	LandReinforcement(208);
	Suicide();
end;
end;

function Reinf209()
-- Town Inf --
	if GetIGlobalVar("TownStatus.2", 0) == 1 then
	LandReinforcement(209);
	Suicide();
end;
end;

function Reinf211()
-- CounterBatt --
--	if GetIGlobalVar("GermanArtState.0", 0) == 1 then
	if GetIGlobalVar("Objective.3.Count", 0) == 1 then
	LandReinforcement(211);
	Cmd(3, 211, 6312, 12220);
	QCmd(1, 211, 107);
	Suicide();
end;
end;

function Reinf213()
-- Mines Arm --
	if GetIGlobalVar("Mines.1", 0) == 1 then
	LandReinforcement(213);
	Suicide();
end;
end;

function Reinf215() 
-- 1st Priest --
	if GetIGlobalVar("PriestCount.0", 0) == 1 then
	LandReinforcement(215);
	Suicide();
end;
end;

function Reinf216() -- NEW --
	if GetIGlobalVar("Objective.5.Start", 0) == 1 then
	LandReinforcement(216);
	RunScript("R216_Count", 3000); -- NEW --
	Suicide();
end;
end;

function Reinf238() -- NEW --
	if GetIGlobalVar("Objective.4.Start", 0) == 1 then
	LandReinforcement(238);
	Suicide();
end;
end;

function Reinf239() -- NEW --
	if GetIGlobalVar("Objective.6.Complete", 0) == 1 then
	LandReinforcement(239);
	Suicide();
end;
end;

function Reinf240() 
	if GetIGlobalVar("Objective.3.Complete", 0) == 1 then
	LandReinforcement(240);
	Suicide();
end;
end;

function Reinf241() 
	if GetIGlobalVar("Objective.4.Count", 0) == 1 then
	LandReinforcement(241);
	Cmd(3, 241, 1800, 7645);
	QCmd(3, 241, 1080, 12930);
	QCmd(3, 241, 5666, 13810);
	QCmd(3, 241,6900, 11275);
	Cmd(3, 242, 4140, 8895);
	QCmd(3, 242,6900, 11275);
	QCmd(3, 242, 5666, 13810);
	QCmd(3, 242, 2175, 13345);
	QCmd(3, 242, 259, 9485);	
	Suicide();
end;
end;

function Reinf243() 
	if GetIGlobalVar("Objective.2.Complete", 0) == 1 then
	LandReinforcement(243);
	Suicide();
end;
end;

function Reinf251() -- NEW --
	if GetIGlobalVar("Objective.4.Count", 0) == 1 then
	LandReinforcement(243);
	Suicide();
end;
end;

----- PATROL ROUTINES -----

function PatrolControl()
	RunScript("Patrol1", 3000);
	RunScript("Patrol2", 3000);
	RunScript("Patrol3", 3000);
	--RunScript("Patrol4", 3000); now started 60sec after objective--
	RunScript("Patrol5", 3000); 
	RunScript("Patrol6", 3000);
	Suicide();
end;

function Patrol1()  --OK--
--Near Town (222) --
	if GetIGlobalVar("Objective.3.Start", 0) == 1 and
	(GetNScriptUnitsInArea(222, "Patrol1") > 0) then
	Cmd(3, 222, 16023, 9455);
	QCmd(3 , 222, 12958, 9920);
	QCmd(3 , 222, 14635, 7990);
	RunScript("Patrol1", 20000);
	Suicide();
end;
end;

function Patrol2() --OK--
-- Mountain Inf & M8 (223) --
	if GetIGlobalVar("Objective.2.Start", 0) == 1 and
	(GetNScriptUnitsInArea(223, "Patrol2") > 0) then
	Cmd(3, 223, 11258, 13137);
	QCmd(3 , 223, 8249, 13635);
	QCmd(3 , 223, 8833, 10948);
	RunScript("Patrol2", 20000);
	Suicide();

end;
end;

function Patrol3() --OK--
-- E Bivio Road (224) --
	if GetIGlobalVar("Objective.2.Start", 0) == 1 and
	(GetNScriptUnitsInArea(224, "Patrol3") > 0) then
	Cmd(3, 224, 3721, 9353);
	QCmd(3 , 224, 7846, 8948); -- NEW --
	RunScript("Patrol3", 20000);
	Suicide();
end;
end;

function Patrol4() --OK--
-- Tre Inf (225) --
	if GetIGlobalVar("Objective.2.Start", 0) == 1 and
	(GetNScriptUnitsInArea(225, "Patrol4") > 0) then
	Cmd(3, 225, 5022, 10670);
	QCmd(3 , 225, 7363, 11208);
	QCmd(3 , 225, 7110, 10229);
	RunScript("Patrol4", 20000);
	Suicide();
end;
end;

function Patrol5() 
-- GB Humbers (226) --
	if GetIGlobalVar("Patrol.5", 0) == 1 then
	Cmd(3, 226, 831, 13897);
	QCmd(3 , 226, 1490, 10614);
	RunScript("Patrol5", 20000);
	Suicide();
end;
end;

function Patrol6() --OK--
-- Bridge Guard (221) --
	if GetIGlobalVar("TownStatus.1", 0) == 1 and
	(GetNScriptUnitsInArea(221, "Patrol6") > 0) then
	Cmd(3, 221, 14934, 4714);
	QCmd(3 , 221, 17597, 4139);
	RunScript("Patrol6", 20000);
	Suicide();
end;
end;

function Patrol7() --NEW--
-- West(240) --
	if (GetNScriptUnitsInArea(240, "Patrol7") > 0)then
	Cmd(3, 240, 4540, 6175);
	QCmd(3 , 240, 2800, 5950);
	QCmd(3 , 240, 3625, 4590);
	QCmd(3 , 240, 5850, 4945);
	RunScript("Patrol7", 20000);
	Suicide();
end;
end;

----- AVIATION -----

function AviationControl() --OK--
	RunScript("Luftwaffe1", 3000);
	RunScript("Luftwaffe2", 3000);
	RunScript("Airstrike_Bivio_Call", 3000);
	RunScript("Airstrike_Batt2", 3000);
	RunScript("Airstrike_Farm", 60000);
	RunScript("Airstrike_Town", 20000);
	RunScript("BattPrep", 3000);
	Suicide();
end;


function PlanesIn() -- NEW --
	--DisplayTrace("Appui arien Alls disponible"); -- TESTING --
	EnableAviation(1, 0);
	EnableAviation(1, 1);
	RunScript("PlanesOut", 240000 + RandomInt(120000));
	Suicide();
end;

function PlanesOut() -- NEW --
	ReserveAviationForTimes(1, 195000);
	--DisplayTrace("Appui arien Alls indisponible");-- TESTING --
	DisableAviation(1, 0);
	DisableAviation(1, 3);
	DisableAviation(1, 4);
	RunScript("PlanesIn", 300000 + RandomInt(180000));
	Suicide();
end;


function Luftwaffe1() --OK--
	if GetIGlobalVar("Objective.2.Complete", 0) == 1 then
	DisplayTrace("Comme d'habitude, la Luftwaffe a promis ses bombardiers en appui.");
	EnableAviation(0, 3);
	Suicide();
end;
end;

function Luftwaffe2() --OK--
	if GetIGlobalVar("Objective.5.Start", 0) == 1 then
	DisplayTrace("FieldMarshal Kesselring a oblig la Luftwaffe  vous dtacher une Kette de JU-87 pour appuyer votre contre-attaque.");
	EnableAviation(0, 4);
	Suicide();
end;
end;

function BattPrep() -- NEW --
	if GetIGlobalVar("Batt.1", 0) ==1 then
	DisableAviation(1, 0);
	DisableAviation(1, 1);
	SetIGlobalVar("Batt.Prep", 1);
	RunScript("PlanesIn", 500000);
	Suicide();
end;
end;
	
function Airstrike_Batt2()
	if GetIGlobalVar("Batt.2", 0) == 1 and
	GetIGlobalVar("Batt.Prep", 0) == 1 then
	EnableAviation(1, 4);
	Cmd(36, 99, 1, 11881, 1585);
	RunScript("Airstrike_Batt2_Complete", 1000);
	Suicide();
end;
end;

function Airstrike_Batt2_Complete()
	DisableAviation(1, 4);
	SetIGlobalVar("Batt.2", 2); 
	-- RunScript("PlanesIn", 2000); -- NEW --
	KillScript("Airstrike_Batt2", 1000);
	KillScript("Batt2", 1000); 
	KillScript("BattPrep", 2000); -- NEW --
	Suicide();
end;	
	
function Airstrike_Bivio_Call() -- NEW --
	if GetIGlobalVar("Objective.3.Count", 0) == 1 and
	GetIGlobalVar("BomberPrep.1", 0) == 1 then
	RunScript("Airstrike_Bivio", 1000);
	Suicide();
	else
	RunScript("Airstrike_Bivio_Call", 30000, 3)
	Suicide();
end;
end;

function Airstrike_Bivio()
	EnableAviation(1, 3);
	Cmd(19, 999, 1, 2117, 10217); 
	RunScript("Airstrike_Bivio_Complete", 1000);
	Suicide();
end;

function Airtrike_Bivio_Complete()
	DisableAviation(1, 3);
	RunScript("PlanesIn", 2000); -- NEW --
	SetIGlobalVar("Objective.3.Count", 2 + 1); -- NEW --
	KillScript("Airstrike_Bivio", 1000);
	KillScript("Airstrike_Bivio_Call", 2000); -- NEW --
	Suicide();
end;


function Airstrike_Town()
	if GetIGlobalVar("TownStatus.3", 0) ==1 then
	EnableAviation(1, 4);
	Cmd(36, 99, 1, 17826, 9310);
	RunScript("Airstrike_Town_Complete", 1000);
	Suicide();
end;
end;

function Airstrike_Town_Complete()
	DisableAviation(1, -1);
	-- RunScript("PlanesIn", 2000); -- NEW --
	SetIGlobalVar("TownStatus.3", 2); 
	KillScript("Airstrike_Town", 1000);
	KillScript("TownCount3", 1000); 
	Suicide();
end;

	
